Loading...
Searching...
No Matches
Sip_content_encoding

## Macros

#define | sip_content_encoding(sip)
| Access a SIP Content-Encoding header structure sip_content_encoding_t from sip_t.
#define | SIP_CONTENT_ENCODING_INIT()
| Initializer for structure sip_content_encoding_t.
#define | SIPTAG_CONTENT_ENCODING(x)
| Tag list item for pointer to a Content-Encoding header structure sip_content_encoding_t.
#define | SIPTAG_CONTENT_ENCODING_REF(x)
| Tag list item for reference to a Content-Encoding header pointer.
#define | SIPTAG_CONTENT_ENCODING_STR(s)
| Tag list item for string with Content-Encoding header value.
#define | SIPTAG_CONTENT_ENCODING_STR_REF(x)
| Tag list item for reference to a Content-Encoding header string.

## Typedefs

typedef msg_list_t | sip_content_encoding_t
| @

## Functions

issize_t | sip_content_encoding_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Content-Encoding header.
issize_t | sip_content_encoding_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Content-Encoding header.
sip_content_encoding_t * | sip_content_encoding_init (sip_content_encoding_t x[1])
| Initialize a structure sip_content_encoding_t.
int | sip_is_content_encoding (sip_header_t const *header)
| Test if header object is instance of sip_content_encoding_t.
sip_content_encoding_t * | sip_content_encoding_dup (su_home_t *home, sip_content_encoding_t const *hdr))
| Duplicate a list of Content-Encoding header header structures sip_content_encoding_t.
sip_content_encoding_t * | sip_content_encoding_copy (su_home_t *home, sip_content_encoding_t const *hdr))
| Copy a list of Content-Encoding header header structures sip_content_encoding_t.
sip_content_encoding_t * | sip_content_encoding_make (su_home_t *home, char const *s))
| Make a Content-Encoding header structure sip_content_encoding_t.
sip_content_encoding_t * | sip_content_encoding_format (su_home_t *home, char const *fmt,...)))
| Make a Content-Encoding header from formatting result.

## Variables

msg_hclass_t | sip_content_encoding_class []
| Header class for Content-Encoding header.
tag_typedef_t | siptag_content_encoding
| Tag for Content-Encoding header object.
tag_typedef_t | siptag_content_encoding_str
| Tag for string with Content-Encoding header value.

## Detailed Description

## Macro Definition Documentation

## SIP_CONTENT_ENCODING_INIT

#define SIP_CONTENT_ENCODING_INIT | ( |  | ) |

Initializer for structure sip_content_encoding_t.

A static sip_content_encoding_t structure for Content-Encoding header must be initialized with the SIP_CONTENT_ENCODING_INIT() macro. For instance,

sip_content_encoding_t sip_content_encoding = SIP_CONTENT_ENCODING_INIT;
SIP_CONTENT_ENCODING_INIT
#define SIP_CONTENT_ENCODING_INIT()
Initializer for structure sip_content_encoding_t.
Definition sip_protos.h:15142
sip_content_encoding_t
msg_list_t sip_content_encoding_t
@
Definition sip.h:152
sip_content_encoding
#define sip_content_encoding(sip)
Access a SIP Content-Encoding header structure sip_content_encoding_t from sip_t.
Definition sip_protos.h:15125

## SIPTAG_CONTENT_ENCODING

#define SIPTAG_CONTENT_ENCODING | ( |  | x | ) |

Tag list item for pointer to a Content-Encoding header structure sip_content_encoding_t.

The SIPTAG_CONTENT_ENCODING() macro is used to include a tag item with a pointer to a sip_content_encoding_t structure in a tag list.

Parameters

  x | pointer to a sip_content_encoding_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_CONTENT_ENCODING_REF().

## SIPTAG_CONTENT_ENCODING_STR

#define SIPTAG_CONTENT_ENCODING_STR | ( |  | s | ) |

Tag list item for string with Content-Encoding header value.

The SIPTAG_CONTENT_ENCODING_STR() macro is used to include a tag item with a string containing value of a sip_content_encoding_t header in a tag list.

Parameters

  s | pointer to a string containing Content-Encoding header value, or NULL.

The string in SIPTAG_CONTENT_ENCODING_STR() can be converted to a sip_content_encoding_t header structure by giving the string s has second argument to function sip_content_encoding_make().

The corresponding tag taking reference parameter is SIPTAG_CONTENT_ENCODING_STR_REF().

## Typedef Documentation

## sip_content_encoding_t

typedef msg_list_t sip_content_encoding_t

@

The Content-Encoding header indicates what additional content codings have been applied to the entity-body. Its syntax is defined in RFC 3261 as follows:

Content-Encoding = ( "Content-Encoding" / "e" ) HCOLON
content-coding *(COMMA content-coding)
content-coding = token

The parsed Content-Encoding header is stored in sip_content_encoding_t structure.

The structure sip_content_encoding_t contains representation of an Content-Encoding header.

The sip_content_encoding_t is defined as follows:

typedef struct msg_list_s
{
msg_common_t k_common[1]; // Common fragment info
msg_list_t *k_next; // Link to next header
msg_param_t *k_items; // List of items
} sip_content_encoding_t;
msg_list_t
struct msg_list_s msg_list_t
msg_common_t
struct msg_common_s msg_common_t
msg_list_s
msg_list_s::k_common
msg_common_t k_common[1]
msg_list_s::k_next
msg_list_t * k_next
msg_list_s::k_items
msg_param_t * k_items

## Function Documentation

## sip_content_encoding_copy()

sip_content_encoding_t * sip_content_encoding_copy | ( | su_home_t * | home,
|  | sip_content_encoding_t const * | hdr )

inline

Copy a list of Content-Encoding header header structures sip_content_encoding_t.

The function sip_content_encoding_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  content_encoding = sip_content_encoding_copy(home, sip->sip_content_encoding);
  sip_content_encoding_copy
  sip_content_encoding_t * sip_content_encoding_copy(su_home_t *home, sip_content_encoding_t const *hdr))
  Copy a list of Content-Encoding header header structures sip_content_encoding_t.
  Definition sip_protos.h:15272

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_content_encoding_dup()

sip_content_encoding_t * sip_content_encoding_dup | ( | su_home_t * | home,
|  | sip_content_encoding_t const * | hdr )

inline

Duplicate a list of Content-Encoding header header structures sip_content_encoding_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  content_encoding = sip_content_encoding_dup(home, sip->sip_content_encoding);
  sip_content_encoding_dup
  sip_content_encoding_t * sip_content_encoding_dup(su_home_t *home, sip_content_encoding_t const *hdr))
  Duplicate a list of Content-Encoding header header structures sip_content_encoding_t.
  Definition sip_protos.h:15229

Returns
  A pointer to the newly duplicated sip_content_encoding_t header structure, or NULL upon an error.

## sip_content_encoding_format()

sip_content_encoding_t * sip_content_encoding_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Content-Encoding header from formatting result.

Make a new sip_content_encoding_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_content_encoding_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_content_encoding_init()

sip_content_encoding_t * sip_content_encoding_init | ( | sip_content_encoding_t | x[1] | ) |

inline

Initialize a structure sip_content_encoding_t.

An sip_content_encoding_t structure for Content-Encoding header can be initialized with the sip_content_encoding_init() function/macro. For instance,

sip_content_encoding_t sip_content_encoding;
sip_content_encoding_init(&sip_content_encoding);
sip_content_encoding_init
sip_content_encoding_t * sip_content_encoding_init(sip_content_encoding_t x[1])
Initialize a structure sip_content_encoding_t.
Definition sip_protos.h:15160

## sip_content_encoding_make()

sip_content_encoding_t * sip_content_encoding_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Content-Encoding header structure sip_content_encoding_t.

The function sip_content_encoding_make() makes a new sip_content_encoding_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_content_encoding_t header structure, or NULL upon an error.

## sip_is_content_encoding()

int sip_is_content_encoding | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_content_encoding_t.

Check if the header class is an instance of Content-Encoding header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header content_encoding
  0 | (false) otherwise

## Variable Documentation

## sip_content_encoding_class

msg_hclass_t sip_content_encoding_class[]

extern

Header class for Content-Encoding header.

The header class sip_content_encoding_class defines how a SIP Content-Encoding header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_content_encoding_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.